program btenum;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  JwaBluetoothAPIs in 'JWA\JwaBluetoothAPIs.pas',
  JwaWinVer in 'JWA\JwaWinVer.pas',
  JwaBthSdpDef in 'JWA\JwaBthSdpDef.pas',
  JwaCdErr in 'JWA\JwaCdErr.pas',
  JwaDde in 'JWA\JwaDde.pas',
  JwaDlgs in 'JWA\JwaDlgs.pas',
  JwaExcpt in 'JWA\JwaExcpt.pas',
  JwaNb30 in 'JWA\JwaNb30.pas',
  JwaNtStatus in 'JWA\JwaNtStatus.pas',
  JwaQos in 'JWA\JwaQos.pas',
  JwaReason in 'JWA\JwaReason.pas',
  JwaRpc in 'JWA\JwaRpc.pas',
  JwaRpcASync in 'JWA\JwaRpcASync.pas',
  JwaRpcDce in 'JWA\JwaRpcDce.pas',
  JwaRpcNsi in 'JWA\JwaRpcNsi.pas',
  JwaRpcNtErr in 'JWA\JwaRpcNtErr.pas',
  JwaRpcSsl in 'JWA\JwaRpcSsl.pas',
  JwaWinBase in 'JWA\JwaWinBase.pas',
  JwaWinCon in 'JWA\JwaWinCon.pas',
  JwaWinCrypt in 'JWA\JwaWinCrypt.pas',
  JwaWinDLLNames in 'JWA\JwaWinDLLNames.pas',
  JwaWindows in 'JWA\JwaWindows.pas',
  JwaWinEFS in 'JWA\JwaWinEFS.pas',
  JwaWinError in 'JWA\JwaWinError.pas',
  JwaWinGDI in 'JWA\JwaWinGDI.pas',
  JwaWinNetWk in 'JWA\JwaWinNetWk.pas',
  JwaWinNLS in 'JWA\JwaWinNLS.pas',
  JwaWinNT in 'JWA\JwaWinNT.pas',
  JwaWinPerf in 'JWA\JwaWinPerf.pas',
  JwaWinReg in 'JWA\JwaWinReg.pas',
  JwaWinsock2 in 'JWA\JwaWinsock2.pas',
  JwaWinSock in 'JWA\JwaWinSock.pas',
  JwaWinSvc in 'JWA\JwaWinSvc.pas',
  JwaWinType in 'JWA\JwaWinType.pas',
  JwaWinUser in 'JWA\JwaWinUser.pas';

function AddressToStr(Adr: BLUETOOTH_ADDRESS): string;
var
  Loop: byte;
begin
  Result := IntToHex(Adr.rgBytes[0], 2);
  //  !!!
  for Loop := 1 to 5 do Result := IntToHex(Adr.rgBytes[Loop], 2) + ':' + Result;
end;

procedure GetRadioInfo(hRadio: THandle);
var
  RadioInfo: BLUETOOTH_RADIO_INFO;
begin
  //   BLUETOOTH_RADIO_INFO
  FillChar(RadioInfo, 0, SizeOf(RadioInfo));
  RadioInfo.dwSize := SizeOf(RadioInfo);

  //  
  if (BluetoothGetRadioInfo(hRadio, RadioInfo) = ERROR_SUCCESS) then begin
    //   
    WriteLn('Device: ', RadioInfo.szName);
    WriteLn('----------------------------------------------------');
    WriteLn('  Address       : ', AddressToStr(RadioInfo.address));
    WriteLn('  ClassOfDevice : ', RadioInfo.ulClassofDevice);
    WriteLn('  Subversion    : ', RadioInfo.lmpSubversion);
    WriteLn('  Manufacturer  : ', RadioInfo.manufacturer);
    WriteLn;
  end;
end;

procedure EnumRadio;
var
  hRadio: THandle;
  BFRP: BLUETOOTH_FIND_RADIO_PARAMS;
  hFind: HBLUETOOTH_RADIO_FIND;
begin
  //   BLUETOOTH_FIND_RADIO_PARAMS
  BFRP.dwSize := SizeOf(BFRP);

  //  
  hFind := BluetoothFindFirstRadio(@BFRP, hRadio);
  if (hFind <> 0) then begin
    repeat
      // -    
      GetRadioInfo(hRadio);

      //   
      CloseHandle(hRadio);

      //   
    until (not BluetoothFindNextRadio(hFind, hRadio));

    //  
    BluetoothFindRadioClose(hFind);
  end;
end;

begin
  EnumRadio;
end.
